module pgroup_base
implicit none

!.... a thechnical information about all point groups is stored here.
!  NAZ() - names of all point group operations ordered according to C()
!  GNAM0 - names of all possible subgroups of Oh and D6h
!  NGROU1 - elements of all subgroups of D6h
!  NGROUP - elements of all subgroups of Oh
!  GNAM   - all groups names (in the same order)
!  N_of_E - number of elements in every group in both families
!
!     common /all_groups/ NGROU1,NGROUP,N_of_E, &
!                        GNAM,NAZ,GNAM0
      integer :: NGROU1(24,54),NGROUP(48,98),N_of_E(98,2)
      character :: GNAM0(30)*3,GNAM(98,2)*3
!........ point group elements are explicitly named here
      character*4,dimension(64) ::  &
      NAZ=(/'UNIT',' C4Z',' C4Y',' C4X',' C2Z','-C4Z', &
       ' C2X','-C4X',' C2Y','-C4Y', &
      ' C3D',' C3C',' C3A',' C3B','-C3D','-C3C','-C3A','-C3B', &
      ' C22',' C21',' C26',' C25',' C23',' C24', &
      ' PXY',' PYZ',' PXZ', &
      ' S4Z',' S4X',' S4Y','S4Z3','S4X3','S4Y3',' S3A','S3A2', &
      ' S3B',' S3C',' S3D','S3B2','S3C2','S3D2','  P1','  P2', &
      '  P3','  P4','  P5','  P6','   I',' C6z',' C3z','-C3z', &
      '-C6z','Cxy-','Cyx-',' Cyx',' Cxy','-S3z','-S6z',' S6z', &
      ' S3z','Pxy-','Pyx-',' Pyx',' Pxy'/)

!.................. all groups names ...................................
      data GNAM /'C1 ','O  ','Oh ','C4 ','D4 ','D4h','C4h','C4v', &
                 'D4 ','D4h','C4 ','C4v','C4h','D4 ','D4h','C4 ', &
                 'C4v','C4h','C2 ','D2 ','T  ','Th ','Td ','D2h', &
                 'D2d','D2d','D2d','D2 ','D2h','D2d','C2h','C2v', &
                 'S4 ','C2v','C2 ','D2 ','D2d','D2h','C2v','C2h', &
                 'S4 ','C2v','C2 ','D2 ','D2d','D2h','C2v','C2h', &
                 'S4 ','C2v','C3 ','D3 ','D3d','C3i','C3v','C3 ', &
                 'D3 ','D3d','C3i','C3v','C3 ','D3 ','D3d','C3i', &
                 'C3v','C3 ','D3 ','D3d','C3i','C3v','C2 ','C2v', &
                 'C2h','C2 ','C2v','C2h','C2 ','C2v','C2h','C2 ', &
                 'C2v','C2h','C2 ','C2v','C2h','C2 ','C2v','C2h', &
                  9*'Cs ','Ci ', &
                  'C1 ','C2 ','C2 ','C2 ','C2 ','C2 ','C2 ','C2 ', &
                  'Cs ','Cs ','Cs ','Cs ','Cs ','Cs ','Cs ','Ci ', &
                  'C3 ','C2h','C2h','C2h','C2h','C2h','C2h','C2h', &
                  'C2v','C2v','C2v','C2v','C2v','C2v','C2v','C2v', &
                  'C2v','C3i','C3v','C3v','C3h','D2 ','D2 ','D2 ', &
                  'D3 ','D3 ','D2h','D2h','D2h','D3h','D3h','D3d', &
                  'D3d','C6 ','C6h','C6v','D6 ','D6h',44*'C1 '/
      
!.................. all group names ................................
      data GNAM0 /'C1 ','O  ','Oh ','T  ','Th ','Td ', &
                 'C6 ','C6h','C6v','D6 ','D6h', &
                 'C4 ','D4 ','D4h','C4h','C4v','S4 ', &
                 'C3 ','D3 ','D3d','C3i','C3v','C3h','D3h', &
                 'C2 ','D2 ','D2h','D2d','C2h','C2v'/
!............... all group elements for the D6h family ..................
      DATA NGROU1 /1,23*0,  1,5,22*0,  1,7,22*0,  1,9,22*0,  1,53,22*0, &
       1,54,22*0,  1,55,22*0,  1,56,22*0,  1,25,22*0,  1,26,22*0, &
       1,27,22*0,  1,61,22*0,  1,62,22*0,  1,63,22*0,  1,64,22*0, &
       1,48,22*0,  1,50,51,21*0, 1,5,48,25,20*0,  1,7,48,26,20*0, &
       1,9,48,27,20*0,  1,53,48,61,20*0,  1,54,48,62,20*0, &
       1,55,48,63,20*0, 1,56,48,64,20*0, 1,5,26,27,20*0, 1,5,61,63,20*0, &
       1,5,62,64,20*0, 1,7,25,27,20*0, 1,9,25,26,20*0, 1,53,25,63,20*0, &
       1,54,25,64,20*0, 1,55,25,61,20*0, 1,56,25,62,20*0, &
       1,50,51,48,58,59,18*0, 1,50,51,26,61,64,18*0, &
       1,50,51,27,63,62,18*0, 1,50,51,57,25,60,18*0, 1,5,7,9,20*0, &
       1,5,53,55,20*0, 1,5,54,56,20*0, 1,50,51,7,53,56,18*0, &
       1,50,51,9,55,54,18*0, 1,7,9,5,48,26,27,25,16*0, &
       1,5,53,55,48,25,61,63,16*0, 1,5,54,56,48,25,62,64,16*0, &
       1,50,51,7,53,56,57,25,60,27,63,62,12*0, 1,50,51,9,55,54,57,25,60, &
       26,61,64,12*0, 1,50,51,7,53,56,48,58,59,26,61,64,12*0, 1,50,51,9, &
       54,55,48,58,59,27,62,63,12*0, 1,49,50,5,51,52,18*0, 1,49,50,5,51, &
       52,48,59,58,25,57,60,12*0, 1,49,50,5,51,52,26,61,64,27,63,62,12*0, &
       1,49,50,5,51,52,9,55,54,7,53,56,12*0, 1,49,50,5,51,52,9,55,54,7, &
       53,56,48,57,58,25,59,60,27,63,62,26,61,64/
!............... all group elements for the Oh family ....................
      DATA NGROUP /1,47*0, 1,7,5,9,16,18,13,11,12,14,17,15,8,6,10,4,2,3, &
       24,23,19,20,21,22,24*0, 1,7,5,9,16,18,13,11,12,14,17,15,8,6,10,4, &
       2,3,24,23,19,20,21,22,48,26,25,27,40,39,34,38,37,36,35,41,32,31, &
       33,29,28,30,45,44,43,42,47,46, 1,5,2,6,44*0, 1,7,9,5,2,6,19,20, &
       40*0, 1,7,9,5,2,6,19,20,48,26,27,25,28,31,43,42,32*0, 1,5,2,6,48, &
       25,28,31,40*0, 1,5,2,6,26,27,43,42,40*0, 1,7,5,9,3,10,23,24,40*0, &
       1,5,7,9,3,10,24,23,48,25,26,27,30,33,45,44,32*0, 1,9,10,3,44*0, &
       1,9,3,10,25,26,45,44,40*0, 1,9,3,10,48,27,30,33,40*0, 1,22,21,7, &
       4,8,9,5,40*0, 1,5,9,7,4,8,22,21,48,25,27,26,29,32,46,47,32*0, &
       1,7,4,8,44*0, 1,7,4,8,25,27,46,47,40*0, 1,7,4,8,48,26,29,32,40*0, &
       1,5,46*0, 1,7,9,5,44*0, 1,7,5,9,16,18,13,11,12,14,17,15,36*0, &
       1,7,5,9,16,18,13,11,12,14,17,15,48,26,25,27,40,39,34,38,37,36,35, &
       41,24*0, 1,7,5,9,16,18,13,11,12,14,17,15,32,31,33,29,28,30,45,44, &
       43,42,47,46,24*0, 1,7,9,5,48,26,27,25,40*0, 1,7,9,5,31,28,42,43, &
       40*0, 1,5,9,7,32,29,47,46,40*0,1,7,5,9,33,30,45,44,40*0,1, &
       19,20,5,44*0,1,5,20,19,48,25,42,43,40*0, &
!
       1,19,20,5,31,28,26,27,40*0,1,5,48,25,44*0,1, &
       5,26,27,44*0,1, &
       5,31,28,44*0,1,5,42,43,44*0,1,7,46*0,1,21,22,7,44*0,1, &
       21,22,7,32,29,27,25,40*0,1,7,22,21,48,26,46,47,40*0,1, &
       7,25,27,44*0,1,7,48,26,44*0,1,7,32,29,44*0,1,7,46,47,44*0,1, &
       9,46*0,1,23,24,9,44*0,1,23,24,9,33,30,26,25,40*0,1, &
       9,23,24,48,27,44,45,40*0,1,9,25,26,44*0,1,9,48,27,44*0,1, &
       9,33,30,44*0, &
!
       1,9,44,45,44*0,1,11,15,45*0,1, &
       11,15,19,24,22,42*0,1,11,15,24,22,19,48,38,41,45,46,43,36*0,1, &
       11,15,48,38,41,42*0,1,11,15,43,45,46,42*0,1,12,16,45*0,1, &
       12,16,20,22,23,42*0,1,12,16,22,23,20,48,37,40,46,44,42,36*0,1, &
       12,16,48,37,40,42*0,1,12,16,42,46,44,42*0,1,13,17,45*0,1, &
       13,17,20,24,21,42*0,1,13,17,24,21,20,48,34,35,45,47,42,36*0,1, &
       13,17,48,34,35,42*0,1,13,17,42,45,47,42*0,1,14,18,45*0,1, &
       14,18,19,21,23,42*0,1,14,18,23,19,21,48,36,39,44,43,47,36*0,1, &
       14,18,48,36,39,42*0,1,14,18,43,47,44,42*0,1,19,46*0,1, &
       19,25,42,44*0,1,19,48,43,44*0,1,20,46*0,1,20,25,43,44*0,1, &
       20,48,42,44*0,1,21,46*0,1,21,26,46,44*0, &
!
       1,21,48,47,44*0,1,22,46*0,1, &
       22,26,47,44*0,1,22,48,46,44*0,1,23,46*0,1, &
       23,27,45,44*0,1,23,48,44,44*0,1,24,46*0,1,24,27,44,44*0,1, &
       24,48,45,44*0,1,25,46*0,1,26,46*0,1,27,46*0,1,42,46*0,1, &
       43,46*0,1,44,46*0,1,45,46*0,1,46,46*0,1,47,46*0,1,48,46*0/
  
end module pgroup_base
